summaryrefslogtreecommitdiffstats
path: root/misc
diff options
context:
space:
mode:
authorMarc Gilleron <marc.gilleron@gmail.com>2021-02-01 00:15:22 +0000
committerMarc Gilleron <marc.gilleron@gmail.com>2021-02-03 22:04:45 +0000
commit1f7f66d09e251fb5b3b2c1d6af43b738425f890f (patch)
treed2b6b77aceda8b41ddd16bf71b03321f03f74ee0 /misc
parent9598fd5c8ed10d10c2923e7bb117fafb37daf77e (diff)
downloadredot-cpp-1f7f66d09e251fb5b3b2c1d6af43b738425f890f.tar.gz
Re-added clang-format checks to the CI
Diffstat (limited to 'misc')
-rw-r--r--misc/scripts/clang_format.sh43
-rwxr-xr-xmisc/travis/clang-format.sh48
2 files changed, 43 insertions, 48 deletions
diff --git a/misc/scripts/clang_format.sh b/misc/scripts/clang_format.sh
new file mode 100644
index 0000000..0d1511e
--- /dev/null
+++ b/misc/scripts/clang_format.sh
@@ -0,0 +1,43 @@
+#!/usr/bin/env bash
+
+# This script runs clang-format on all relevant files in the repo.
+# This is the primary script responsible for fixing style violations.
+
+set -uo pipefail
+IFS=$'\n\t'
+
+CLANG_FORMAT_FILE_EXTS=(".c" ".h" ".cpp" ".hpp" ".cc" ".hh" ".cxx" ".m" ".mm" ".inc" ".java" ".glsl")
+
+# Loops through all text files tracked by Git.
+git grep -zIl '' |
+while IFS= read -rd '' f; do
+ # Exclude some files.
+ if [[ "$f" == "thirdparty"* ]]; then
+ continue
+ fi
+
+ for extension in ${CLANG_FORMAT_FILE_EXTS[@]}; do
+ if [[ "$f" == *"$extension" ]]; then
+ # Run clang-format.
+ clang-format -i "$f"
+ continue 2
+ fi
+ done
+done
+
+git diff > patch.patch
+
+# If no patch has been generated all is OK, clean up, and exit.
+if [ ! -s patch.patch ] ; then
+ printf "Files in this commit comply with the clang-format style rules.\n"
+ rm -f patch.patch
+ exit 0
+fi
+
+# A patch has been created, notify the user, clean up, and exit.
+printf "\n*** The following differences were found between the code "
+printf "and the formatting rules:\n\n"
+cat patch.patch
+printf "\n*** Aborting, please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
+rm -f patch.patch
+exit 1
diff --git a/misc/travis/clang-format.sh b/misc/travis/clang-format.sh
deleted file mode 100755
index 5a41fcc..0000000
--- a/misc/travis/clang-format.sh
+++ /dev/null
@@ -1,48 +0,0 @@
-#!/bin/sh
-
-CLANG_FORMAT=clang-format-8
-
-if [ "$TRAVIS_PULL_REQUEST" != "false" ]; then
- # Travis only clones the PR branch and uses its HEAD commit as detached HEAD,
- # so it's problematic when we want an exact commit range for format checks.
- # We fetch upstream to ensure that we have the proper references to resolve.
- # Ideally we would use $TRAVIS_COMMIT_RANGE but it doesn't play well with PR
- # updates, as it only includes changes since the previous state of the PR.
- if [ -z "$(git remote | grep upstream)" ]; then
- git remote add upstream https://github.com/godotengine/godot-cpp \
- --no-tags -f -t $TRAVIS_BRANCH
- fi
- RANGE="upstream/$TRAVIS_BRANCH HEAD"
-else
- # Test only the last commit, since $TRAVIS_COMMIT_RANGE wouldn't support
- # force pushes.
- RANGE=HEAD
-fi
-
-FILES=$(git diff-tree --no-commit-id --name-only -r $RANGE | grep -E "\.(c|h|cpp|hpp|cc|hh|cxx|m|mm|inc|java|glsl)$")
-echo "Checking files:\n$FILES"
-
-# create a random filename to store our generated patch
-prefix="static-check-clang-format"
-suffix="$(date +%s)"
-patch="/tmp/$prefix-$suffix.patch"
-
-for file in $FILES; do
- "$CLANG_FORMAT" -style=file "$file" | \
- diff -u "$file" - | \
- sed -e "1s|--- |--- a/|" -e "2s|+++ -|+++ b/$file|" >> "$patch"
-done
-
-# if no patch has been generated all is ok, clean up the file stub and exit
-if [ ! -s "$patch" ] ; then
- printf "Files in this commit comply with the clang-format rules.\n"
- rm -f "$patch"
- exit 0
-fi
-
-# a patch has been created, notify the user and exit
-printf "\n*** The following differences were found between the code to commit "
-printf "and the clang-format rules:\n\n"
-cat "$patch"
-printf "\n*** Aborting, please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
-exit 1